#!/usr/bin/env python

# Used to plot the example of missing 3 bottom GOBs in frame 8.

from matplotlib.pylab import *

FBIR_050 = 0
FBIR_200 = 1
IPLR = 2

filename = ["mini/fbir-050.psnr", "mini/fbir-200.psnr", "mini/iplr.psnr"]
psnr = [[], [], []]

for i in range(3):
    f = file(filename[i], 'r')
    for j in range(50):
        psnr[i].append(float(f.readline()[-6:]))
    f.close()

figure(1)
t = range(50)
hold(True)
plot(t, psnr[FBIR_050], '-bo', label='FBIR 50 ms')
plot(t, psnr[FBIR_200], '-gx', label='FBIR 200 ms')
plot(t, psnr[IPLR], '-r+', label='IPLR')
axis([0, 30, 25, 50])
xlabel("Frame no.")
ylabel("Y-PSNR (dB)")
title("Recovery behaviour")
legend()
savefig("recovery-behaviour.eps")



