#include "defines.h"

#if RTP_BIG_ENDIAN_SUPPORT

#include "global.h"


/*
 * Test if system is big endian. Returns 0 for little endian and 1 for big
 * endian.
 */
int isBigEndian()
{
  short s;
  byte *p;

  p=(byte*)&s;

  s=1;

  return (*p==0);
}

/*
 * Swap between big endian and little endian, and vice versa.
 */
unsigned long ByteSwapLong (unsigned long number)
{
  return (((number&0x000000FF)<<24)+((number&0x0000FF00)<<8)+
          ((number&0x00FF0000)>>8)+((number&0xFF000000)>>24));
}

/*
 * Swap between big endian and little endian, and vice versa.
 */
unsigned short ByteSwapShort (unsigned short number)
{
  return (((number>> 8)) | (number << 8));
}

#endif
