
/*! \file
 *     contributors.h
 *  \brief
 *     List of contributors and copyright information.
 *
 *  \par Copyright statements
    \verbatim
   H.264 JM coder/decoder

   Copyright (C) 2000 by
      Telenor Broadband Services, Norway
      Ericsson Radio Systems, Sweden
      TELES AG, Germany
      Nokia Inc., USA
      Nokia Corporation, Finland
      Siemens AG, Germany
      Heinrich-Hertz-Institute for Communication Technology GmbH, Germany
      University of Hannover, Institut of Communication Theory and Signal Processing,Germany
      Videolocus, Canada
	  LSI Logic, Canada
      Motorola Inc., USA
      Microsoft Corp., USA
      Apple Computer, Inc.
      RealNetworks, Inc., USA
      Thomson, Inc., USA
   \endverbatim
   \par Full Contact Information
   \verbatim

      Lowell Winger                   <lwinger@videolocus.com><lwinger@uwaterloo.ca><lwinger@lsil.com>
      Guy Ct                        <gcote@videolocus.com>
      Michael Gallant                 <mgallant@videolocus.com>
      VideoLocus Inc.
      97 Randall Dr.
      Waterloo, ON, Canada  N2V1C5

      Inge Lille-Langy               <inge.lille-langoy@telenor.com>
      Telenor Broadband Services
      P.O.Box 6914 St.Olavs plass
      N-0130 Oslo, Norway

      Rickard Sjoberg                 <rickard.sjoberg@era.ericsson.se>
      Ericsson Radio Systems
      KI/ERA/T/VV
      164 80 Stockholm, Sweden

      Stephan Wenger                  <stewe@cs.tu-berlin.de>
      TU Berlin / TELES AG
      Sekr. FR 6-3
      Franklinstr. 28-29
      D-10587 Berlin, Germany

      Jani Lainema                    <jani.lainema@nokia.com>
      Nokia Inc. / Nokia Research Center
      6000 Connection Drive
      Irving, TX 75039, USA

      Sebastian Purreiter             <sebastian.purreiter@mch.siemens.de>
      Siemens AG
      ICM MD MP RD MCH 83
      P.O.Box 80 17 07
      D-81617 Munich, Germany

      Thomas Wedi                     <wedi@tnt.uni-hannover.de>
      University of Hannover
      Institut of Communication Theory and Signal Processing
      Appelstr. 9a
      30167 Hannover

      Thomas Stockhammer              <stockhammer@ei.tum.de>
      Institute for Communications Engineering
      Munich University of Technology
      80290 Munich
      Germany

      Detlev Marpe                    <marpe@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Guido Heising                   <heising@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Ragip Kurceren                  <ragip.kurceren@nokia.com>
      Nokia Inc. / Nokia Research Center
      6000 Connection Drive
      Irving, TX 75039, USA

      Tobias Oelbaum (TO)             <drehvial@gmx.net>
      Institute for Communications Engineering
      Munich University of Technology
      80290 Munich
      Germany

      Yann Le Maguet                  <yann.lemaguet@philips.com>
      Philips Research France

      Dong Tian                       <tian@cs.tut.fi>
      Ye-Kui Wang                     <wyk@ieee.org>
      Tampere University of Technology
      Tampere International Center for Signal Processing
      33720 Tampere, Finland

      Miska M. Hannuksela             <miska.hannuksela@nokia.com>
      Nokia Corporation / Nokia Mobile Phones
      P.O. Box 88
      33721 Tampere, Finland

      Karsten Suehring                <suehring@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Heiko Schwarz                   <hschwarz@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Limin Wang                      <liwang@gi.com>
      Krit Panusopone                 <kpanusopone@gi.com>
      Rajeev Gandhi                   <rgandhi@gi.com>
      Yue Yu                          <yyu@gi.com>
      Motorola Inc.
      6450 Sequence Drive
      San Diego, CA 92121 USA

      Feng Wu                         <fengwu@microsoft.com>
      Xiaoyan Sun                     <sunxiaoyan@msrchina.research.microsoft.com>
      Microsoft Research Asia
      3/F, Beijing Sigma Center
      No.49, Zhichun Road, Hai Dian District,
      Beijing China 100080


      Mathias Wien                    <wien@ient.rwth-aachen.de>
      Institut und Lehrstuhl fr Nachrichtentechnik
      RWTH Aachen University
      52072 Aachen
      Germany

      Achim Dahlhoff                  <dahlhoff@ient.rwth-aachen.de>
      Institut und Lehrstuhl fr Nachrichtentechnik
      RWTH Aachen University
      52072 Aachen
      Germany

      Yoshihiro Kikuchi               <yoshihiro.kikuchi@toshiba.co.jp>
      Takeshi Chujoh                  <takeshi.chujoh@toshiba.co.jp>
      Toshiba Corporation
      Research and Development Center
      Kawasaki 212-8582, Japan

      Shinya Kadono                   <kadono@drl.mei.co.jp>
      Matsushita Electric Industrial Co., Ltd.
      1006 Kadoma, Kadoma
      Osaka 663-8113, Japan

      Dzung Hoang                     <dzung.hoang@conexant.com>
      Eric Viscito                    <eric.viscito@conexant.com>
      Conexant Systems. Inc.
      MPEG Compression Group
      20450 Stevens Creek Blvd.
      Cupertino, CA 95014

      Barry Haskell
      Apple Computer, Inc.            <bhaskell@apple.com>
      2 Infinite Loop
      Cupertino, California 95014

      Greg Conklin
      RealNetworks, Inc.              <gregc@real.com>
      2601 Elliott Ave
      Seattle, WA 98101

      Jill Boyce                      <jill.boyce@thomson.net>
      Cristina Gomila                 <cristina.gomila@thomson.net>
      Thomson
      2 Independence Way
      Princeton, NJ 08540
      
      Siwei Ma                        <swma@jdl.ac.cn>
      Institute of Computing Technology
      Chinese Academy of Sciences 
      Kexueyuan South Road 6
      Haidian District
      Beijing, China
      
      Zhibo Chen                      <chenzhibo@tsinghua.org.cn>
      JianFeng Xu                     <fenax@video.mdc.tsinghua.edu.cn>
      Wenfang Fu                      <fwf@video.mdc.tsinghua.edu.cn>
      Dept.of E&E, Tsinghua Univ
      Haidian District 
      Beijing China, 100084
        
      Alexis Michael Tourapis         <alexismt@ieee.org>
  
      Xiaoquan Yi                     <xyi@engr.scu.edu>
      Jun Zhang                       <jzhang2@engr.scu.edu>
      Dept. of C.E. Santa Clara Univ.
      500 El Camino Real 
      Santa Clara, CA 95053

   \endverbatim
 */

