#include "defines.h"

#if FBIR

#ifndef _FBIR_H_
#define _FBIR_H_

#define ET_DEBUG_ENABLE 0

#define MV_MEMORY_SIZE 15               /* number of frames */
#define MAX_MOTION_WHEN_STATIC 2        
#define CR_LIMIT 1                      /* min. CR for setting MB as corrupt */

#define CR_NO_CORRUPTED_MBS -1
#define CR_STATIC_MB -2
#define CR_ALL_MBS_CHECKED -3
#define CR_CORRUPTION_WAITING -4

typedef struct{
  unsigned int lost;                    /* #MBs reported as lost */
  unsigned int corr;                    /* #MBs marked corrupted */
  unsigned long corr_total;             /* #MBs corrupted in total time and
                                         * space */
  unsigned int corr_under_limit;        /* #MBs corrupted but under limit */
  unsigned int refreshed;               /* #MBs refreshed because of corruption */
  unsigned int static_;                 /* #MBs corrupted but not refreshed
                                            because of static MB */
  float avg_refresh_time;                   /* avg frames until MBs are refreshed */
  short last_fb_time;              /* refresh time for the latest MB */
} fbir_stats_t;
fbir_stats_t fbir_stats;

void fbir_init();
void fbir_free();
void fbir_log_write();

int mb_corruption (int pic, int mb, int intra, int last_non_static);
void register_lost_packet (int seq);
void et_store_info(int intra);

#endif  /* _FBIR_H_ */
#endif  /* FBIR */
