#include "defines.h"

#if GILBERT_IN_ENCODER
#ifndef _GILBERT_H_
#define _GILBERT_H_

#include <stdio.h>

/* 0: print only statistics, 1: print also packets lost */
#define GILBERT_VERBOSE_MODE 1

typedef enum {
    LOSSY,
    NON_LOSSY
}gilbertState;

typedef struct {
    int nPackets;
    int nPacketsLost;
    int nBursts;
    float avgBurstLength;
    int currentBurstLength;
    FILE *file;
} gilbertStat;

typedef struct {
    float q;     /* transition prob. from lossy to non-lossy state */
    float p;     /* transition prob. from non-lossy to lossy state */
    gilbertState state;
}gilbertModel;

void initGilbertModel();
void freeGilbertModel();
int simLossyNetwork(int seq);

#endif
#endif
